=== core/data/metadata/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2019, Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

install(FILES       ${CMAKE_CURRENT_SOURCE_DIR}/topicset.iptc-subjectcode.xml
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/metadata
)
