=== debian/changelog ===
digikam (4:8.0.0~+beta1-0ubuntu3) lunar; urgency=medium

  * No-change rebuild against libtiff6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 05 Feb 2023 03:57:51 +0000

digikam (4:8.0.0~+beta1-0ubuntu2) lunar; urgency=medium

  * Include test suite in included-binaries
  * Patch to disable git checkout of test suite
  * Re-enable test suite using included-binaries

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Thu, 26 Jan 2023 16:53:18 -0800

digikam (4:8.0.0~+beta1-0ubuntu1) lunar; urgency=medium

  * New upstream beta release
  * Refreshed patch
  * Disable build tests which require git download

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Sat, 24 Dec 2022 08:45:30 -0800
